mixer = {};

--todo
-- 1)self:getFillLevel() > 0 and no entry -> no exhaustEffect +
-- 2)self:getFillLevel() > 0 and entry and motor_not_started -> too much exhaust -
-- 3)do dynamic flap +/- -> replace angle to update


function mixer.prerequisitesPresent(specializations)
    return true;
end;

function mixer:load(savegame)
    self.tank = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.mixer.tank#index"));
    self.flap = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.mixer.exhaust#flap"));
	self.exhaustEmitter = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.mixer.exhaust#emitter"));

	self.doCheckSpeedLimit = Utils.overwrittenFunction(self.doCheckSpeedLimit, mixer.doCheckSpeedLimit)
	self.getCanTipToGround = Utils.overwrittenFunction(self.getCanTipToGround, mixer.getCanTipToGround);
	
    IdleSound = Utils.getFilename("sounds/idle.wav", self.baseDirectory);
    self.IdleSound = createSample("IdleSound");
    loadSample(self.IdleSound, IdleSound, false);
    self.IdleSound3D = createAudioSource("IdleSound3D", IdleSound, 25, 25, 0.6, 0);
    link(self.components[1].node, self.IdleSound3D);
    setVisibility(self.IdleSound3D, false);
	self.exhaustState = false;
end;

function mixer:delete()
    if self.IdleSound ~= nil then
        delete(self.IdleSound);
    end;
end;

function mixer:update(dt)	
	for _, effect in pairs(self.exhaustEffects) do
		setVisibility(effect.effectNode, self.exhaustState);
	end;	
    if self:getIsActive() then
		if self:getFillLevel() > 0 then
			self.exhaustState = true;
			local angle = Utils.lerp(-0.1, 0.1, math.random()) + 120;
			-- print (angle);
			setRotation(self.flap, angle, 0, 0);
			if not getVisibility(self.IdleSound3D) then
					setVisibility(self.IdleSound3D, true);
			end;
			if (self.tipState == Trailer.TIPSTATE_OPEN) then
					rotate(self.tank, 0, 0, 1/20 );
				elseif (self.tipState == Trailer.TIPSTATE_OPENING) then
					rotate(self.tank, 0, 0, 1/40 );
				else
					rotate(self.tank, 0, 0, -1/(20 + self:getLastSpeed()));
			end;						
		else
			if getVisibility(self.IdleSound3D) then
				setVisibility(self.IdleSound3D, false);	
			end;
			self.exhaustState = false;
			setRotation(self.flap, 0, 0, 0);					
		end;
	else
		if self:getFillLevel() > 0 then
			rotate(self.tank, 0, 0, -1/20 );
			self.exhaustState = true;
			local angle = Utils.lerp(-0.1, 0.1, math.random()) + 120;
			-- print (angle);
			setRotation(self.flap, angle, 0, 0);
			if not getVisibility(self.IdleSound3D) then					
				setVisibility(self.IdleSound3D, true);				
			end;
		else
			if getVisibility(self.IdleSound3D) then
				setVisibility(self.IdleSound3D, false);			
			end;
			self.exhaustState = false;
			setRotation(self.flap, 0, 0, 0);				
		end;
	end;
end;

function mixer:updateTick(dt)
end

function mixer:doCheckSpeedLimit(superFunc)
	
	local parent = false;
    if superFunc ~= nil then
        parent = superFunc(self);
    end	
    return parent or ( self:getFillLevel() > 0 );		
end

function mixer:getDefaultSpeedLimit()
	return 60
end

function mixer:getCanTipToGround(superFunc)
	return false
end

function mixer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function mixer:keyEvent(unicode, sym, modifier, isDown)
end;

function mixer:draw()
	if self:getFillLevel() > 0 then
		g_currentMission:addExtraPrintText(g_i18n:getText("MIXER_SPEED_LIMIT"));
	end
end;

function mixer:onEnter()
end;

function mixer:onLeave()
end;

